/*version 1 Patrón de caminado pierna derecha 3 estados
 * 0 grados arriba, -180/180 abajo
 En esta version se mueve la pierna a partir de que se de la señal desde el joystick, siguiendo el patron de caminado con tres estados
 * 1)Cadera se mantiene, rodilla en reversa hasta llegar a 145 grados con respecto al eje vertical. 
 * 2) Cadera hacia adelante en aproximadamente -135 grados con respecto a su eje vertical y rodilla en reversa buscando el paralelo con us eje vertical.
 * 3) Cadera y rodilla alineadas ambas a -150 grados con respecto a la vertical.
 * 4) Cadera y rodilla alineadas ambas a -180 grados con respecto a la vertical.
 * 
 * Se utilizan dos lecturas (x,y) de dos acelerometros diferentes ya que los angulos son en el plano xy.
 * Se controlan dos motores con 2 pines digitales que indican la direccion, un PWM para modular velocidad, un habilitador analogico y un 
 * sensor de corriente analogico, por cada motor.
 * 
 * En esta version el joystick controla el inicio del patron de caminado (v adelante) y el stop total de ambos motores(boton).
 * ASUME QUE INICIA EN POSTURA(cad y rod en -180)
 * Pendientes.
 *  -Codigo asume que inicia en ambos acelerometros en 0 grados, reinicie al estado inicial.
 *  -Proteccion por si no esta en el estado adecuado
 *  -Control de velocidades
 */

#define brake 0         //Brake GND
#define cw 1            //direccion clockwise, A positivo B negativo
#define ccw 2           //Direccion counterclockwise, B positivo, A negativo
#define cs_threshold 100 

int inApin[2] = {7, 4};  // INA: Clockwise input
int inBpin[2] = {8, 9}; // INB: Counter-clockwise input
int pwmpin[2] = {5, 6}; // PWM input
int cspin[2] = {A2, A3}; // CS: Current sense ANALOG input
int enpin[2] = {0, 1}; // EN: Status of switches output (Analog pin)

#define motor1 0    //motor de rodilla
#define motor2 1    //motor de cadera


//Joystick
#define xPin A6     //xAxis H
#define yPin A7     //yAxis V
#define button 52   //Button digital

short usSpeed = 33;   //default motor speed

unsigned short usMotor_Status = brake; //variable que indica el estado del motor, ya se cw, ccw o brake. Se inicializa en brake

//variable para  entradas por serial
char input;

//Joystick
int xPos =0;
int yPos = 0;
int buttonState = 0;

// variables MMA7361
#define pi 3.141592

int Leg = 1; //pierna derecha
//variables acelerometro rodilla
float sensorValue1 = 0;
float sensorValue2 = 0;
float *axy_arrayg;
float *axy_arrayp;
float *axy_arraybfo2;
float aux;
float ax = 0;
float ay = 0;
long ang_rod; //ANGULO RODILLA
float axbfo2 = 0;
float axbfo2_array[2] = {0, 0};
float aybfo2 = 0;
float aybfo2_array[2] = {0, 0};

//variables acelerometro cadera

float sensorValue3 = 0;
float sensorValue4 = 0;
float *axy_arrayg_1;
float *axy_arrayp_1;
float *axy_arraybfo2_1;
float aux_1;
float ax_1 = 0;
float ay_1 = 0;
long ang_cad = 0; //ANGULO CADERA
float axbfo2_1 = 0;
float axbfo2_array_1[2] = {0, 0};
float aybfo2_1 = 0;
float aybfo2_array_1[2] = {0, 0};

float Taux4 = 0;
float acum = 0;

void setup(){
  Serial.begin(9600);
  
 // Initialize digital pins as outputs
  for (int i=0; i<2; i++)
  {
    pinMode(inApin[i], OUTPUT);
    pinMode(inBpin[i], OUTPUT);
    pinMode(pwmpin[i], OUTPUT);
  }

  //Joystick
  pinMode(xPin, INPUT);
  pinMode(yPin, INPUT);
  pinMode(button, INPUT);
    pinMode(13, OUTPUT);
  
  Serial.println("ALICE Motor Control");
  Serial.println(); 
  Serial.println("Enter number for control option:");
  Serial.println("1. Stop");
  Serial.println("Up. Forward");
  Serial.println("Down. Reverse");
  Serial.println();

//Motores inician en BRAKE GND
 for (int i=0; i<2; i++)
  {
    digitalWrite(inApin[i], LOW);
    digitalWrite(inBpin[i], LOW);
  }
}

void loop(){ 
    //Joystick
    xPos = analogRead(xPin);
    yPos = analogRead(yPin);
    buttonState = digitalRead(button);
    if(buttonState==0)
      StopBoth();
    if(xPos == 0 && (yPos>=505 && yPos<=515)) //Se;al de inicio RightLeg
    {
      Start(0,0);
      Serial.println("FIN");
    }
 }

void Start(int cont0, int cont1)
{
  /*Utiliza ciclos para mantener actualizadas las lecturas del acelerometro ante los cambios en movimiento
  -Busca que ambos sensores se acomoden entre si, en un rango de diferencias considerando el error de lectura,es decir
   que cuando esten alineados la diferencia entre estos sensores sea de 0-10 grados.
  -en cada estado esta la posibilidad de llegar a un paro total.
  -Cuando se llegue a la posicion deseada en cada fase se detienen ambos motores
  -Hay una espera de 2 segundos en cada estado
  -Algunos valores de angulos estan un poco desfasados de los angulos deseados, esto es para que el motor se alcance a detener y termine 
  en la posicion adecuada
      
    Notas sobre las velocidades de cada motor:
    -La flecha de la cadera se barria ligeramente por lo que se modificaba la velocidad default, ademas del cambio que se 
    hacia por el peso que cargaba ese motor, esta velocidad deberia ser 33 con la pieza ideal
    -La flecha de la rodilla estaba un poco justa o apretada por lo que ocupaba mayor velocidad para arrancar, en lugar de 33, 45*/
  /*Secuencia:
    1.Pre-swing
    2.Inicial
    3.Regreso
    4.Postura
    */
  while(cont0==0||cont1==0)
  {
    acelerometro();
    buttonState = digitalRead(button);
    if((ang_rod>145 && ang_rod>0) || (ang_rod>-180 && ang_rod<0))
    {
      usSpeed=50;
      Reverse(0);
    }
    if(abs(ang_cad)-ang_rod>=5 && ang_rod>0)
    {
      Stop(0);
      cont0++;
      cont1++;
    } if(buttonState==0|| input==' ')
      { Serial.println("STOPBO");
        StopBoth();
        cont0=4;
        cont1=4;}   
  }
  Serial.println("END Pre-swing");
  Serial.println(cont0);
  Serial.println(cont1);
  delay(2000);
  
  while(cont0==1||cont1==1)
  {
    acelerometro();
    buttonState = digitalRead(button);
    
    if(((ang_cad<-130 && ang_cad<0)||(ang_cad>0))&& cont1==1)
    {
      usSpeed=46;//velocidad por cosita amrilla quese barre un poquito
      Forward(1);
    }      
    
    if(ang_cad>=-135 && ang_cad<=-120)
    {
      Stop(1);
      cont1++;
      cont0++;
    }

    if(buttonState==0|| input==' ')
      { Serial.println("STOPBO");
        StopBoth();
        cont0=4;
        cont1=4;
      }
  }
  Serial.println("END Inicial");
  delay(2000);
  while(cont0==2||cont1==2)
  {
    acelerometro();
    buttonState = digitalRead(button);
    if((ang_cad>=-145 && ang_cad<0)||(ang_cad>0))
    {
      usSpeed=40;//velocidad por cosita amrilla quese barre un poquito
      Reverse(1);
    }      
    if((ang_rod<-145 && ang_rod<0)||ang_rod>0)
    {
      usSpeed=45;
      Forward(0);
    }
    if(ang_cad-ang_rod<=20 && ang_cad-ang_rod>=0) 
    {
      Stop(0);
      cont0++;
    }
    if(ang_cad<-135)
    {
      Stop(1);
      cont1++;
    }

    if(buttonState==0|| input==' ')
      { Serial.println("STOPBO");
        StopBoth();
        cont0=4;
        cont1=4;
      }
  }
  Serial.println("END Regreso");
  delay(2000);
  while(cont0==3||cont1==3)
  {
    acelerometro();
    buttonState = digitalRead(button);
    if(ang_cad>-165 && ang_cad<0)
    {
      usSpeed=40; //control temporal de velocidad porque la cosita amarilla esta rota 
      Reverse(1);
    }
  
    if(ang_cad<=-165 ||ang_cad>=0)
    {
      Stop(1);
      cont1++;
      cont0++;
    }

    if(buttonState==0|| input==' ')
      { Serial.println("STOPBO");
        StopBoth();
        cont0=4;
        cont1=4;
       }   
  }
  Serial.println("End Postura");
}


void motorGO(uint8_t motor, uint8_t direct, uint8_t pwm){
  /*Elige entre los estados indicados por direct para indicar la polaridad de A y B, utiliza la variable motor(0 o 1) para indicar que pin es
  en los distintos arreglos de variables*/
  if(motor <=1)
  {
    if(direct == 0)
    {
      digitalWrite(inApin[motor], LOW); 
      digitalWrite(inBpin[motor], LOW);
    }
    else if(direct == 1)
    {
      digitalWrite(inApin[motor], LOW); 
      digitalWrite(inBpin[motor], HIGH);      
    }
    else
    {
      digitalWrite(inApin[motor], HIGH);
      digitalWrite(inBpin[motor], LOW);            
    }
    
    analogWrite(pwmpin[motor], pwm); 
  }
}

void Stop(int motaux) //detiene el motor seleccionado
{
  usMotor_Status = brake;
  motorGO(motaux, usMotor_Status, 0);
  Serial.print("Stop");
  Serial.println(motaux);
}

void Forward(int motaux) //mueve en la dirección fwd el motor indicado y modifica la velocidad para el motor de la cadera
{
  usMotor_Status = cw;
  if(motaux==1){
  usSpeed+=3;//le aumenta velocidad para que le motor batalle menos en subir el peso del motor de la rodilla
  }
  motorGO(motaux, usMotor_Status, usSpeed);
  Serial.print("FWD: ");
  Serial.println(motaux);
}
void Reverse(int motaux)//mueve en la direccion rev el motor indicado y modifica la velocidad para el motor de la cadera
{
  usMotor_Status = ccw;
  if(motaux==1){
  usSpeed-=12;// disminuye velocidad ya que con el peso de la estructura se da el empuje para que el motor arranque
  }
 motorGO(motaux, usMotor_Status, usSpeed);
 Serial.print("REV: ");
 Serial.println(motaux);
}

void StopBoth(){ //detiene ambos motores
  usMotor_Status=brake;
  motorGO(motor1, usMotor_Status, 0);
  motorGO(motor2, usMotor_Status, 0);
}
//void IncreaseSpeed()
//{
//  usSpeed = usSpeed + 3;
//  if(usSpeed > 255)
//  {
//    usSpeed = 255;  
//  }
//  
//  Serial.print("Speed +: ");
//  Serial.println(usSpeed);
//
//  motorGO(motor1, usMotor_Status, usSpeed);
//  motorGO(motor2, usMotor_Status, usSpeed);  
//}

//void DecreaseSpeed()
//{
//  usSpeed = usSpeed - 3;
//  if(usSpeed < 0)
//  {
//    usSpeed = 0;  
//  }
//  
//  Serial.print("Speed -: ");
//  Serial.println(usSpeed);
//
//  motorGO(motor1, usMotor_Status, usSpeed);
//  motorGO(motor2, usMotor_Status, usSpeed);  
//}

void acelerometro(){
  Taux4 = micros();
  ang_rod = (long)angle(0);
  ang_cad= (long)angle(1);
  acum = acum + (micros() - Taux4);

  Serial.print("Rodilla: ");
  Serial.print(ang_rod);
  Serial.print("   Cadera: ");
  Serial.println(ang_cad);
}
float  angle(int acelaux_a) {
  float ang_rodaux;
  float ang_cadaux;
   sensorValue1 = analogRead(A8);//x
  sensorValue2 = analogRead(A9);//y
  sensorValue3 = analogRead(A5);//x1
  sensorValue4 = analogRead(A4);//y2
  //entradas analogicas del primer sensor
  if(acelaux_a==0){

  axy_arrayg = g_calibration();//apuntador a float axy_arrayg se le asigna lo que regresa la funcion g_calibration
  ax = axy_arrayg[0];
  ay = axy_arrayg[1];

  aux = sqrt(pow(ax, 2) + pow(ay, 2));//hipotenusa de ax y ay
  ax = ax * 9.81 / aux;//cuanto de 9.81 tiene la componenete en x
  ay = ay * 9.81 / aux;
  
  axy_arrayp = p_calibration(acelaux_a);//apuntador a float se le asigna lo que regresa p_calibration
  ax = axy_arrayp[0];
  ay = axy_arrayp[1];

  axy_arraybfo2 = butter_filter_o2(acelaux_a);
  axbfo2 = axy_arraybfo2[0];
  aybfo2 = axy_arraybfo2[1];

  ang_rodaux = (atan2(aybfo2, axbfo2)) * 180.0 / pi;
  return(ang_rodaux);
  }

  else{
   //entradas analogicas del segundo sensor
  axy_arrayg_1 = g_calibration();//apuntador a float axy_arrayg se le asigna lo que regresa la funcion g_calibration
  ax_1= axy_arrayg_1[2];
  ay_1 = axy_arrayg_1[3];

  aux_1 = sqrt(pow(ax_1, 2) + pow(ay_1, 2));//hipotenusa de ax y ay
  ax_1 = ax_1 * 9.81 / aux_1;//cuanto de 9.81 tiene la componenete en x
  ay_1 = ay_1 * 9.81 / aux_1;
  
  axy_arrayp_1 = p_calibration(acelaux_a);//apuntador a float se le asigna lo que regresa p_calibration
  ax_1 = axy_arrayp_1[0];
  ay_1 = axy_arrayp_1[1];

  axy_arraybfo2_1 = butter_filter_o2(acelaux_a);
  axbfo2_1 = axy_arraybfo2_1[0];
  aybfo2_1 = axy_arraybfo2_1[1];

  ang_cadaux = (atan2(aybfo2_1, axbfo2_1)) * 180.0 / pi;
  return (ang_cadaux);
  }
}

float * g_calibration() {
  static float axy_g[2];//
  switch (Leg)
  {
    case 1:
      axy_g[0] = -(sensorValue1 - 323.3) * 9.81 / 158.24;
      axy_g[1] = -(sensorValue2 - 343.493) * 9.81 / 164.393;
      axy_g[2] = -(sensorValue3 - 327.5) * 9.81 / 162.5;
      axy_g[3] = -(sensorValue4 - 340) * 9.81 / 160;
      break;
    default:
      axy_g[0] = 0;
      axy_g[1] = 100;
      axy_g[2] = 0;
      axy_g[3] = 100;
      break;
  }
  return (axy_g);//regresa arreglo de floats
}

float * p_calibration(int acelaux_p) {
  static float axy_p[2];
  static float axy_p_1[2];
  if (acelaux_p == 0) {
    switch (Leg)
    {
      case 1:
        axy_p[0] = 0.987938601113301 * ax + -0.154846118550949 * ay;
        axy_p[1] = -(-0.154846118550949) * ax + 0.987938601113301 * ay;
        break;
      default:
        axy_p[0] = 50;
        axy_p[1] = 150;
        break;
    }
    return (axy_p);
  }
  else {
    switch (Leg)
    {
      case 1:
        axy_p_1[0] = 0.987938601113301 * ax_1 + -0.154846118550949 * ay_1;
        axy_p_1[1] = -(-0.154846118550949) * ax_1 + 0.987938601113301 * ay_1;
        break;
      default:
        axy_p_1[0] = 50;
        axy_p_1[1] = 150;
        break;
    }
    return (axy_p_1);
  }
}

float * butter_filter_o2(int acelaux_bfo2) {
  static float axy_bfo2[2];
  static float axy_bfo2_1[2];
  if (acelaux_bfo2 == 0) {
    switch (Leg)
    {
      case 1:
        axy_bfo2[0] = (ax + 37.6568 * axbfo2_array[0] - 16.0 * axbfo2_array[1]) / 22.6568;
        axbfo2_array[1] = axbfo2_array[0];
        axbfo2_array[0] = axy_bfo2[0];

        axy_bfo2[1] = (ay + 37.6568 * aybfo2_array[0] - 16.0 * aybfo2_array[1]) / 22.6568;
        aybfo2_array[1] = aybfo2_array[0];
        aybfo2_array[0] = axy_bfo2[1];
        break;
      default:
        axy_bfo2[0] = 1;
        axy_bfo2[1] = 1;
        break;
    }
    return (axy_bfo2);
  }
  else {
    switch (Leg)
    {
      case 1:
        axy_bfo2_1[0] = (ax_1 + 37.6568 * axbfo2_array_1[0] - 16.0 * axbfo2_array_1[1]) / 22.6568;
        axbfo2_array_1[1] = axbfo2_array_1[0];
        axbfo2_array_1[0] = axy_bfo2_1[0];

        axy_bfo2_1[1] = (ay_1 + 37.6568 * aybfo2_array_1[0] - 16.0 * aybfo2_array_1[1]) / 22.6568;
        aybfo2_array_1[1] = aybfo2_array_1[0];
        aybfo2_array_1[0] = axy_bfo2_1[1];
        break;
      default:
        axy_bfo2_1[0] = 1;
        axy_bfo2_1[1] = 1;
        break;
    }
    return (axy_bfo2_1);
  }
}
